%define upstream_name Log-Any-IfLOG
%define upstream_version 0.090

%{?perl_default_filter}

Name:       perl-%{upstream_name}
Version:    %perl_convert_version %{upstream_version}
Release:    %mkrel 3

Summary:    Load Log::Any only if "logging is enabled"
License:    GPL+ or Artistic
Group:      Development/Perl
Url:        https://metacpan.org/release/%{upstream_name}
Source0:    https://cpan.metacpan.org/modules/by-module/Log/%{upstream_name}-%{upstream_version}.tar.gz

BuildRequires: perl(ExtUtils::MakeMaker)
BuildRequires: perl(File::Spec)
BuildRequires: perl(IO::Handle)
BuildRequires: perl(IPC::Open3)
BuildRequires: perl(Log::Any)
BuildRequires: perl(Test::More)
BuildArch:  noarch

%description
This module is a drop-in replacement/wrapper for Log::Any to be used
from your modules. This is a quick-hack solution to avoid the cost of
loading Log::Any under "normal condition". Since Log::Any 1.00, startup
overhead increases to about 7-10ms on my PC/laptop (from under 1ms for
the previous version). Because I want to keep startup overhead of CLI
apps under 50ms (see Perinci::CmdLine::Lite) to keep tab completion
from getting a noticeable lag, every millisecond counts.

This module will only load Log::Any when "logging is enabled".
Otherwise, it will just return without loading anything. If $log is
requested in import, a fake object is returned that responds to methods
like debug, is_debug and so on but will do nothing when called and just
return 0.

To determine "logging is enabled":

  * Is $ENABLE_LOG defined?

  This package variable can be used to force "logging enabled" (if
  true) or "logging disabled" (if false). Normally, you don't need to
  do this except for testing.

  * Is Log::Any is already loaded (from %INC)?

  If Log::Any is already loaded, it means we have taken the overhead
  hit anyway so logging is enabled.

  * Is one of log-related environment variables true?

  If one of LOG, TRACE, or DEBUG, or VERBOSE, or QUIET, or LOG_LEVEL is
  true then logging is enabled. These variables are used by
  Perinci::CmdLine.

  Otherwise, logging is disabled.

%prep
%autosetup -n %{upstream_name}-%{upstream_version}

%build
%__perl Makefile.PL INSTALLDIRS=vendor

%make_build

%check
%make_build test

%install
%make_install

%files
%doc Changes LICENSE META.json META.yml MYMETA.yml README
%{_mandir}/man3/*
%{perl_vendorlib}/*

%changelog
* Mon Mar 21 2022 umeabot <umeabot> 0.90.0-3.mga9
+ Revision: 1811249
- Mageia 9 Mass Rebuild

* Fri Feb 14 2020 umeabot <umeabot> 0.90.0-2.mga8
+ Revision: 1522011
- Mageia 8 Mass Rebuild
+ wally <wally>
- replace deprecated %%makeinstall_std

* Fri Jan 11 2019 tv <tv> 0.90.0-1.mga7
+ Revision: 1355124
- update to 0.090

* Wed Sep 19 2018 umeabot <umeabot> 0.70.0-4.mga7
+ Revision: 1268946
- Mageia 7 Mass Rebuild

* Sun Jun 19 2016 pterjan <pterjan> 0.70.0-3.mga6
+ Revision: 1029318
- Rebuild for perl 5.22.2

* Fri Feb 19 2016 umeabot <umeabot> 0.70.0-2.mga6
+ Revision: 969355
- Mageia 6 Mass Rebuild

* Sun Aug 23 2015 sander85 <sander85> 0.70.0-1.mga6
+ Revision: 868497
- update to 0.07

* Tue Jun 30 2015 sander85 <sander85> 0.50.0-1.mga6
+ Revision: 848819
- imported package perl-Log-Any-IfLOG

